package org.springframework.roo.addon.gwt;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

@Retention(RetentionPolicy.SOURCE)
@Target(ElementType.TYPE)
public @interface RooGwtLocator {

    /**
     * @return the fully-qualified type name this key instance was mirrored from
     */
    String value();

    /**
     * Indicates whether the annotated locator should be instantiated using XML
     * configuration
     * 
     * @return see above
     */
    boolean useXmlConfiguration() default false;

}
